#include <Servo.h>

// Set the pins were used on Arduino UNO for each sensor/actuator. 
const int ServoMotor = 11;
const int RedLed = 5;
const int GreenLed = 6;
const int SlidingPot = A2;
const int FSR = A1;

// Define the variables are used in the script.
int LEDbrightness;
int ServoVal;
float FSRData;
float PotVal;

// Declaration of a new variable "sm" that links the functions of the "Servo.h" library with the code.
Servo sm;

void setup()
{
	Serial.begin(9600);

  // Configuring the behaviour of the sensors.
	pinMode(RedLed, OUTPUT);
	pinMode(GreenLed, OUTPUT);

  // Attaches the servo motor to the pin was set, with an optional operating PWM interval.
	sm.attach(ServoMotor);
  sm.write(0);
}

void loop()
{
  // Reading analog values of the potentiometer and alocate it in the range of motion of the ServoMotor.
	PotVal = analogRead(SlidingPot);
  ServoVal = map(PotVal, 0, 1023, 0, 180);
  
  if (PotVal > 0)
  {
    // Print the mapped values of the ServoMotor.
    sm.write(ServoVal);
    Serial.print("Servo_Motor_Value: ");
    Serial.print(ServoVal);
    Serial.print(", ");

    // Print the values of the potentiometer.
    Serial.print("Potentiometer_Value: ");
    Serial.print(PotVal);
    Serial.print(", ");
    
    // Print the values of the FSR sensor.
	  FSRData = analogRead(FSR);
    Serial.print("FSR_Value: ");
    Serial.print(FSRData);
    Serial.println(", ");
    
    // Alocate the values of the ServoMotor into the range of the LED brightness.
    LEDbrightness = map(PotVal, 0, 180, 0, 255);
    analogWrite(GreenLed, LEDbrightness);

  // Setting a threshold of 800 could be according to the intuition of the user considering
  // the range between [0,5] Volts the sensor operates and therefore the board allocates 
  // those values into an intiger range of numbers between [0, 1023].
  if (FSRData > 800)
  {
     // LED light turns on and the ServoMotor detaches from its pin.
     digitalWrite(GreenLed, LOW);
     digitalWrite(RedLed, HIGH);
     sm.detach();

     Serial.println("WARNING_WAIT");
     delay(5000);
     digitalWrite(RedLed, LOW);
     Serial.println("Zero_the_potentiometer_and_remove_the_object.");

     // Attaches the ServoMotor again on its pin and zeros the ServoMotor.
     sm.attach(ServoMotor);
     sm.write(0);
     delay(5000);
   }
  }
  else
  {
    Serial.println("Start_sliding_the_potensiometer.");
    delay(500);
  }
}
